/**
 */
package org.eclipse.gef.dot.internal.language.portpos;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.gef.dot.internal.language.portpos.PortposFactory
 * @model kind="package"
 * @generated
 */
public interface PortposPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "portpos";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://www.eclipse.org/gef/dot/internal/language/DotPortPos";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "portpos";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  PortposPackage eINSTANCE = org.eclipse.gef.dot.internal.language.portpos.impl.PortposPackageImpl.init();

  /**
   * The meta object id for the '{@link org.eclipse.gef.dot.internal.language.portpos.impl.PortPosImpl <em>Port Pos</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.gef.dot.internal.language.portpos.impl.PortPosImpl
   * @see org.eclipse.gef.dot.internal.language.portpos.impl.PortposPackageImpl#getPortPos()
   * @generated
   */
  int PORT_POS = 0;

  /**
   * The feature id for the '<em><b>Port</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_POS__PORT = 0;

  /**
   * The feature id for the '<em><b>Compass Point</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_POS__COMPASS_POINT = 1;

  /**
   * The number of structural features of the '<em>Port Pos</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_POS_FEATURE_COUNT = 2;


  /**
   * Returns the meta object for class '{@link org.eclipse.gef.dot.internal.language.portpos.PortPos <em>Port Pos</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Port Pos</em>'.
   * @see org.eclipse.gef.dot.internal.language.portpos.PortPos
   * @generated
   */
  EClass getPortPos();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.gef.dot.internal.language.portpos.PortPos#getPort <em>Port</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Port</em>'.
   * @see org.eclipse.gef.dot.internal.language.portpos.PortPos#getPort()
   * @see #getPortPos()
   * @generated
   */
  EAttribute getPortPos_Port();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.gef.dot.internal.language.portpos.PortPos#getCompassPoint <em>Compass Point</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Compass Point</em>'.
   * @see org.eclipse.gef.dot.internal.language.portpos.PortPos#getCompassPoint()
   * @see #getPortPos()
   * @generated
   */
  EAttribute getPortPos_CompassPoint();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  PortposFactory getPortposFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.eclipse.gef.dot.internal.language.portpos.impl.PortPosImpl <em>Port Pos</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.eclipse.gef.dot.internal.language.portpos.impl.PortPosImpl
     * @see org.eclipse.gef.dot.internal.language.portpos.impl.PortposPackageImpl#getPortPos()
     * @generated
     */
    EClass PORT_POS = eINSTANCE.getPortPos();

    /**
     * The meta object literal for the '<em><b>Port</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PORT_POS__PORT = eINSTANCE.getPortPos_Port();

    /**
     * The meta object literal for the '<em><b>Compass Point</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PORT_POS__COMPASS_POINT = eINSTANCE.getPortPos_CompassPoint();

  }

} //PortposPackage
